warp-3.1.12: A fast, light-weight web server for WAI applications.

Safe Haskell | None
Language | Haskell98

Network.Wai.Handler.Warp.Internal

Contents

- Settings
- Low level run functions
- ServeConnection
- Connection
  - Receive
  - Buffer
  - Sendfile
- Version
- Data types
- Time out manager
  - Types
  - Manager
  - Registration
  - Control
  - Exceptions
- File descriptor cache
- File information cache
- Date
- Request and response

Synopsis

- data Settings = Settings {
  - settingsPort :: Port
  - settingsHost :: HostPreference
  - settingsOnException :: Maybe Request -> SomeException -> IO ()
  - settingsOnExceptionResponse :: SomeException -> Response
  - settingsOnOpen :: SockAddr -> IO Bool
  - settingsOnClose :: SockAddr -> IO ()
  - settingsTimeout :: Int
  - settingsManager :: Maybe Manager
  - settingsFdCacheDuration :: Int
  - settingsFileInfoCacheDuration :: Int
  - settingsBeforeMainLoop :: IO ()
  - settingsFork :: ((forall a. IO a -> IO a) -> IO ()) -> IO ()
  - settingsNoParsePath :: Bool
  - settingsInstallShutdownHandler :: IO () -> IO ()
  - settingsServerName :: ByteString
  - settingsMaximumBodyFlush :: Maybe Int
  - settingsProxyProtocol :: ProxyProtocol
  - settingsSlowlorisSize :: Int
  - settingsHTTP2Enabled :: Bool
  - settingsLogger :: Request -> Status -> Maybe Integer -> IO ()
  }
- data ProxyProtocol
  - = ProxyProtocolNone
  - | ProxyProtocolRequired
  - | ProxyProtocolOptional
- runSettingsConnection :: Settings -> IO (Connection, SockAddr) -> Application -> IO ()
- runSettingsConnectionMaker :: Settings -> IO (IO Connection, SockAddr) -> Application -> IO ()
- runSettingsConnectionMakerSecure :: Settings -> IO (IO (Connection, Transport), SockAddr) -> Application -> IO ()
- runServe :: Port -> ServeConnection -> IO ()
- runServeEnv :: Port -> ServeConnection -> IO ()
- runServeSettings :: Settings -> ServeConnection -> IO ()
- runServeSettingsSocket :: Settings -> Socket -> ServeConnection -> IO ()
- runServeSettingsConnection :: Settings -> IO (Connection, SockAddr) -> ServeConnection -> IO ()
- runServeSettingsConnectionMaker :: Settings -> IO (IO Connection, SockAddr) -> ServeConnection -> IO ()
- runServeSettingsConnectionMakerSecure :: Settings -> IO (IO (Connection, Transport), SockAddr) -> ServeConnection -> IO ()
- data Transport
  - = TCP
  - | TLS {
    - tlsMajorVersion :: Int
    - tlsMinorVersion :: Int
    - tlsNegotiatedProtocol :: Maybe ByteString
    - tlsChiperID :: Word16
    }
- type ServeConnection = Connection -> InternalInfo -> SockAddr -> Transport -> Settings -> IO ()
- serveDefault :: Application -> ServeConnection
- serveHTTP2 :: HTTP2Application -> Application -> ServeConnection
- data Connection = Connection {
  - connSendMany :: [ByteString] -> IO ()
  - connSendAll :: ByteString -> IO ()
  - connSendFile :: SendFile
  - connClose :: IO ()
  - connRecv :: Recv
  - connRecvBuf :: RecvBuf
  - connWriteBuffer :: Buffer
  - connBufferSize :: BufSize
  }
- socketConnection :: Socket -> IO Connection
- type Recv = IO ByteString
- type RecvBuf = Buffer -> BufSize -> IO Bool
- makePlainReceiveN :: Socket -> ByteString -> IO (BufSize -> IO ByteString)
- type Buffer = Ptr Word8
- type BufSize = Int
- bufferSize :: BufSize
- allocateBuffer :: Int -> IO Buffer
- freeBuffer :: Buffer -> IO ()
- copy :: Buffer -> ByteString -> IO Buffer
- data FileId = FileId {
  - fileIdPath :: FilePath
  - fileIdFd :: Maybe Fd
  }
- type SendFile = FileId -> Integer -> Integer -> IO () -> [ByteString] -> IO ()
- sendFile :: Socket -> Buffer -> BufSize -> (ByteString -> IO ()) -> SendFile
- readSendFile :: Buffer -> BufSize -> (ByteString -> IO ()) -> SendFile
- warpVersion :: String
- data InternalInfo = InternalInfo {
  - threadHandle :: Handle
  - timeoutManager :: Manager
  - fdCacher :: Maybe MutableFdCache
  - fileInfo :: FilePath -> IO FileInfo
  - dateCacher :: DateCache
  }
- type HeaderValue = ByteString
- type IndexedHeader = Array Int (Maybe HeaderValue)
- requestMaxIndex :: Int
- type Manager = Reaper [Handle] Handle
- type TimeoutAction = IO ()
- data Handle
- initialize :: Int -> IO Manager
- stopManager :: Manager -> IO ()
- killManager :: Manager -> IO ()
- withManager :: Int -> (Manager -> IO a) -> IO a
- register :: Manager -> TimeoutAction -> IO Handle
- registerKillThread :: Manager -> IO Handle
- tickle :: Handle -> IO ()
- cancel :: Handle -> IO ()
- pause :: Handle -> IO ()
- resume :: Handle -> IO ()
- data TimeoutThread = TimeoutThread
- withFdCache :: Int -> (Maybe MutableFdCache -> IO a) -> IO a
- getFd :: MutableFdCache -> FilePath -> IO (Fd, Refresh)
- type MutableFdCache = Reaper FdCache (Hash, FdEntry)
- type Refresh = IO ()
- data FileInfo = FileInfo {
  - fileInfoName :: !FilePath
  - fileInfoSize :: !Integer
  - fileInfoTime :: HTTPDate
  - fileInfoDate :: ByteString
  }
- withFileInfoCache :: Int -> ((FilePath -> IO FileInfo) -> IO a) -> IO a
- getInfo :: FilePath -> IO FileInfo
- withDateCache :: (DateCache -> IO a) -> IO a
- getDate :: DateCache -> IO GMTDate
- type DateCache = IO GMTDate
- type GMTDate = ByteString
- data Source
- recvRequest :: Settings -> Connection -> InternalInfo -> SockAddr -> Source -> IO (Request, Maybe (IORef Int), IndexedHeader, IO ByteString)
- sendResponse :: Settings -> Connection -> InternalInfo -> Request -> IndexedHeader -> IO ByteString -> Response -> IO Bool

# Settings

data Settings Source

Various Warp server settings. This is purposely kept as an abstract data type so that new settings can be added without breaking backwards compatibility. In order to create a `Settings` value, use `defaultSettings` and the various 'set' functions to modify individual fields. For example:

    setTimeout 20 defaultSettings

Constructors

Settings |

Fields

settingsPort :: Port

  Port to listen on. Default value: 3000

settingsHost :: HostPreference

  Default value: HostIPv4

settingsOnException :: Maybe Request -> SomeException -> IO ()

  What to do with exceptions thrown by either the application or server. Default: ignore server-generated exceptions (see `InvalidRequest`) and print application-generated applications to stderr.

settingsOnExceptionResponse :: SomeException -> Response

  A function to create `Response` when an exception occurs.

  Default: 500, text/plain, "Something went wrong"

  Since 2.0.3

settingsOnOpen :: SockAddr -> IO Bool

  What to do when a connection is open. When `False` is returned, the connection is closed immediately. Otherwise, the connection is going on. Default: always returns `True`.

settingsOnClose :: SockAddr -> IO ()

  What to do when a connection is close. Default: do nothing.

settingsTimeout :: Int

  Timeout value in seconds. Default value: 30

settingsManager :: Maybe Manager

  Use an existing timeout manager instead of spawning a new one. If used, `settingsTimeout` is ignored. Default is `Nothing`

settingsFdCacheDuration :: Int

  Cache duration time of file descriptors in seconds. 0 means that the cache mechanism is not used. Default value: 0

settingsFileInfoCacheDuration :: Int

  Cache duration time of file information in seconds. 0 means that the cache mechanism is not used. Default value: 0

settingsBeforeMainLoop :: IO ()

  Code to run after the listening socket is ready but before entering the main event loop. Useful for signaling to tests that they can start running, or to drop permissions after binding to a restricted port.

  Default: do nothing.

  Since 1.3.6

settingsFork :: ((forall a. IO a -> IO a) -> IO ()) -> IO ()

  Code to fork a new thread to accept a connection.

  This may be useful if you need OS bound threads, or if you wish to develop an alternative threading model.

  Default: void . forkIOWithUnmask

  Since 3.0.4

settingsNoParsePath :: Bool

  Perform no parsing on the rawPathInfo.

  This is useful for writing HTTP proxies.

  Default: False

  Since 2.0.3

settingsInstallShutdownHandler :: IO () -> IO ()
settingsServerName :: ByteString

  Default server name if application does not set one.

  Since 3.0.2

settingsMaximumBodyFlush :: Maybe Int

  See `setMaximumBodyFlush`.

  Since 3.0.3

settingsProxyProtocol :: ProxyProtocol

  Specify usage of the PROXY protocol.

  Since 3.0.5.

settingsSlowlorisSize :: Int

  Size of bytes read to prevent Slowloris protection. Default value: 2048

  Since 3.1.2.

settingsHTTP2Enabled :: Bool

  Whether to enable HTTP2 ALPN/upgrades. Default: True

  Since 3.1.7.

settingsLogger :: Request -> Status -> Maybe Integer -> IO ()

  A log function. Default: no action.

  Since 3.X.X.

data ProxyProtocol Source

Specify usage of the PROXY protocol.

Constructors

ProxyProtocolNone | See `setProxyProtocolNone`.
ProxyProtocolRequired | See `setProxyProtocolRequired`.
ProxyProtocolOptional | See `setProxyProtocolOptional`.

# Low level run functions

runSettingsConnection :: Settings -> IO (Connection, SockAddr) -> Application -> IO () Source

The connection setup action would be expensive. A good example is initialization of TLS. So, this converts the connection setup action to the connection maker which will be executed after forking a new worker thread. Then this calls `runSettingsConnectionMaker` with the connection maker. This allows the expensive computations to be performed in a separate worker thread instead of the main server loop.

Since 1.3.5

runSettingsConnectionMaker :: Settings -> IO (IO Connection, SockAddr) -> Application -> IO () Source

This modifies the connection maker so that it returns `TCP` for `Transport` (i.e. plain HTTP) then calls `runSettingsConnectionMakerSecure`.

runSettingsConnectionMakerSecure :: Settings -> IO (IO (Connection, Transport), SockAddr) -> Application -> IO () Source

The core run function which takes `Settings`, a connection maker and `Application`. The connection maker can return a connection of either plain HTTP or HTTP over TLS.

Since 2.1.4

runServe :: Port -> ServeConnection -> IO () Source

The generalized form of `run`.

runServeEnv :: Port -> ServeConnection -> IO () Source

The generalized form of `runEnv`.

runServeSettings :: Settings -> ServeConnection -> IO () Source

The generalized form of `runSettings`.

runServeSettingsSocket :: Settings -> Socket -> ServeConnection -> IO () Source

The generalized form of `runSettingsSocket`.

runServeSettingsConnection :: Settings -> IO (Connection, SockAddr) -> ServeConnection -> IO () Source

The generalized form of `runSettingsConnection`.

runServeSettingsConnectionMaker :: Settings -> IO (IO Connection, SockAddr) -> ServeConnection -> IO () Source

The generalized form of `runSettingsConnectionMaker`.

runServeSettingsConnectionMakerSecure :: Settings -> IO (IO (Connection, Transport), SockAddr) -> ServeConnection -> IO () Source

The generalized form of `runSettingsConnectionMakerSecure`.

data Transport Source

What kind of transport is used for this connection?

Constructors

TCP | Plain channel: TCP
TLS | Encrypted channel: TLS or SSL

Fields

tlsMajorVersion :: Int
tlsMinorVersion :: Int
tlsNegotiatedProtocol :: Maybe ByteString

  The result of Application Layer Protocol Negociation in RFC 7301

tlsChiperID :: Word16

# ServeConnection

type ServeConnection = Connection -> InternalInfo -> SockAddr -> Transport -> Settings -> IO () Source

serveDefault :: Application -> ServeConnection Source

serveHTTP2 :: HTTP2Application -> Application -> ServeConnection Source

# Connection

data Connection Source

Data type to manipulate IO actions for connections. This is used to abstract IO actions for plain HTTP and HTTP over TLS.

Constructors

Connection |

Fields

connSendMany :: [ByteString] -> IO ()

  This is not used at this moment.

connSendAll :: ByteString -> IO ()

  The sending function.

connSendFile :: SendFile

  The sending function for files in HTTP/1.1.

connClose :: IO ()

  The connection closing function.

connRecv :: Recv

  The connection receiving function. This returns "" for EOF.

connRecvBuf :: RecvBuf

  The connection receiving function. This tries to fill the buffer. This returns when the buffer is filled or reaches EOF.

connWriteBuffer :: Buffer

  The write buffer.

connBufferSize :: BufSize

  The size of the write buffer.

socketConnection :: Socket -> IO Connection Source

Creating `Connection` for plain HTTP based on a given socket.

## Receive

type Recv = IO ByteString Source

Type for the action to receive input data

type RecvBuf = Buffer -> BufSize -> IO Bool Source

Type for the action to receive input data with a buffer. The result boolean indicates whether or not the buffer is fully filled.

makePlainReceiveN :: Socket -> ByteString -> IO (BufSize -> IO ByteString) Source

This function returns a receiving function based on two receiving functions. The returned function efficiently manages received data which is initialized by the first argument. The returned function may allocate a byte string with malloc().

## Buffer

type Buffer = Ptr Word8 Source

Type for buffer

type BufSize = Int Source

Type for buffer size

bufferSize :: BufSize Source

The default size of the write buffer: 16384 (2^14 = 1024 * 16). This is the maximum size of TLS record. This is also the maximum size of HTTP/2 frame payload (excluding frame header).

allocateBuffer :: Int -> IO Buffer Source

Allocating a buffer with malloc().

freeBuffer :: Buffer -> IO () Source

Releasing a buffer with free().

copy :: Buffer -> ByteString -> IO Buffer Source

Copying the bytestring to the buffer. This function returns the point where the next copy should start.

## Sendfile

data FileId Source

Data type to abstract file identifiers. On Unix, a file descriptor would be specified to make use of the file descriptor cache.

Since: 3.1.0

Constructors

FileId |

Fields

fileIdPath :: FilePath
fileIdFd :: Maybe Fd

type SendFile = FileId -> Integer -> Integer -> IO () -> [ByteString] -> IO () Source

fileid, offset, length, hook action, HTTP headers

Since: 3.1.0

sendFile :: Socket -> Buffer -> BufSize -> (ByteString -> IO ()) -> SendFile Source

Function to send a file based on sendfile() for Linux/Mac/FreeBSD. This makes use of the file descriptor cache. For other OSes, this is identical to `readSendFile`.

Since: 3.1.0

readSendFile :: Buffer -> BufSize -> (ByteString -> IO ()) -> SendFile Source

Function to send a file based on pread()/send() for Unix. This makes use of the file descriptor cache. For Windows, this is emulated by `Handle`.

Since: 3.1.0

# Version

warpVersion :: String Source

The version of Warp.

# Data types

data InternalInfo Source

Internal information.

Constructors

InternalInfo |

Fields

threadHandle :: Handle
timeoutManager :: Manager
fdCacher :: Maybe MutableFdCache
fileInfo :: FilePath -> IO FileInfo
dateCacher :: DateCache

type HeaderValue = ByteString Source

The type for header value used with `HeaderName`.

type IndexedHeader = Array Int (Maybe HeaderValue) Source

Array for a set of HTTP headers.

requestMaxIndex :: Int Source

The size for `IndexedHeader` for HTTP Request. From 0 to this corresponds to "Content-Length", "Transfer-Encoding", "Expect", "Connection", "Range", "Host", "If-Modified-Since", "If-Unmodified-Since" and "If-Range".

# Time out manager

In order to provide slowloris protection, Warp provides timeout handlers. We follow these rules:

- A timeout is created when a connection is opened.
- When all request headers are read, the timeout is tickled.
- Every time at least the slowloris size settings number of bytes of the request body are read, the timeout is tickled.
- The timeout is paused while executing user code. This will apply to both the application itself, and a ResponseSource response. The timeout is resumed as soon as we return from user code.
- Every time data is successfully sent to the client, the timeout is tickled.

## Types

type Manager = Reaper [Handle] Handle Source

A timeout manager

type TimeoutAction = IO () Source

An action to be performed on timeout.

data Handle Source

A handle used by `Manager`

## Manager

initialize :: Int -> IO Manager Source

Creating timeout manager which works every N micro seconds where N is the first argument.

stopManager :: Manager -> IO () Source

Stopping timeout manager with onTimeout fired.

killManager :: Manager -> IO () Source

Killing timeout manager immediately without firing onTimeout.

withManager Source

Arguments

:: Int | timeout in microseconds
-> (Manager -> IO a) |
-> IO a |

Call the inner function with a timeout manager.

## Registration

register :: Manager -> TimeoutAction -> IO Handle Source

Registering a timeout action.

registerKillThread :: Manager -> IO Handle Source

Registering a timeout action of killing this thread.

## Control

tickle :: Handle -> IO () Source

Setting the state to active. `Manager` turns active to inactive repeatedly.

cancel :: Handle -> IO () Source

Setting the state to canceled. `Manager` eventually removes this without timeout action.

pause :: Handle -> IO () Source

Setting the state to paused. `Manager` does not change the value.

resume :: Handle -> IO () Source

Setting the paused state to active. This is an alias to `tickle`.

## Exceptions

data TimeoutThread Source

Constructors

TimeoutThread |

Instances

Show TimeoutThread Source |
Exception TimeoutThread Source |

# File descriptor cache

withFdCache :: Int -> (Maybe MutableFdCache -> IO a) -> IO a Source

Creating `MutableFdCache` and executing the action in the second argument. The first argument is a cache duration in second.

getFd :: MutableFdCache -> FilePath -> IO (Fd, Refresh) Source

Getting `Fd` and `Refresh` from the mutable Fd cacher.

type MutableFdCache = Reaper FdCache (Hash, FdEntry) Source

Mutable Fd cacher.

type Refresh = IO () Source

An action to activate a Fd cache entry.

# File information cache

data FileInfo Source

File information.

Constructors

FileInfo |

Fields

fileInfoName :: !FilePath
fileInfoSize :: !Integer
fileInfoTime :: HTTPDate

  Modification time

fileInfoDate :: ByteString

  Modification time in the GMT format

Instances

Eq FileInfo Source |
Show FileInfo Source |

withFileInfoCache :: Int -> ((FilePath -> IO FileInfo) -> IO a) -> IO a Source

Creating a file information cache and executing the action in the second argument. The first argument is a cache duration in second.

getInfo :: FilePath -> IO FileInfo Source

Getting the file information corresponding to the file.

# Date

withDateCache :: (DateCache -> IO a) -> IO a Source

Creating `DateCache` and executing the action.

getDate :: DateCache -> IO GMTDate Source

Getting current `GMTDate` based on `DateCache`.

type DateCache = IO GMTDate Source

The type of the cache of the Date header value.

type GMTDate = ByteString Source

The type of the Date header value.

# Request and response

data Source Source

Type for input streaming.

recvRequest Source

Arguments

:: Settings |
-> Connection |
-> InternalInfo |
-> SockAddr | Peer's address.
-> Source | Where HTTP request comes from.
-> IO (Request, Maybe (IORef Int), IndexedHeader, IO ByteString) | `Request` passed to `Application`, how many bytes remain to be consumed, if known `IndexedHeader` of HTTP request for internal use, Body producing action used for flushing the request body

Receiving a HTTP request from `Connection` and parsing its header to create `Request`.

sendResponse Source

Arguments

:: Settings |
-> Connection |
-> InternalInfo |
-> Request | HTTP request.
-> IndexedHeader | Indexed header of HTTP request.
-> IO ByteString | source from client, for raw response
-> Response | HTTP response including status code and response header.
-> IO Bool | Returing True if the connection is persistent.

Sending a HTTP response to `Connection` according to `Response`.

Applications/middlewares MUST provide a proper `ResponseHeaders`. so that inconsistency does not happen. No header is deleted by this function.

Especially, Applications/middlewares MUST provide a proper Content-Type. They MUST NOT provide Content-Length, Content-Range, and Transfer-Encoding because they are inserted, when necessary, regardless they already exist. This function does not insert Content-Encoding. It's middleware's responsibility.

The Date and Server header is added if not exist in HTTP response header.

There are three basic APIs to create `Response`:

`responseBuilder` :: `Status` -> `ResponseHeaders` -> `Builder` -> `Response`
  HTTP response body is created from `Builder`. Transfer-Encoding: chunked is used in HTTP/1.1.
`responseStream` :: `Status` -> `ResponseHeaders` -> `StreamingBody` -> `Response`
  HTTP response body is created from `Builder`. Transfer-Encoding: chunked is used in HTTP/1.1.
`responseRaw` :: (`IO` `ByteString` -> (`ByteString` -> `IO` ()) -> `IO` ()) -> `Response` -> `Response`
  No header is added and no Transfer-Encoding: is applied.
`responseFile` :: `Status` -> `ResponseHeaders` -> `FilePath` -> `Maybe` `FilePart` -> `Response`
  HTTP response body is sent (by sendfile(), if possible) for GET method. HTTP response body is not sent by HEAD method. Content-Length and Content-Range are automatically added into the HTTP response header if necessary. If Content-Length and Content-Range exist in the HTTP response header, they would cause inconsistency. "Accept-Ranges: bytes" is also inserted.

Applications are categorized into simple and sophisticated. Sophisticated applications should specify `Just` to `Maybe` `FilePart`. They should treat the conditional request by themselves. A proper `Status` (200 or 206) must be provided.

Simple applications should specify `Nothing` to `Maybe` `FilePart`. The size of the specified file is obtained by disk access or from the file infor cache. If-Modified-Since, If-Unmodified-Since, If-Range and Range are processed. Since a proper status is chosen, `Status` is ignored. Last-Modified is inserted.